#include "Character.hpp"

Character::Character(string name,string model_name, Location *location, float initial_angle){
  this->model_name = model_name;
  this->location = location;
  this->ent_name = name;

  step = 10;
  angle = 0;
  this->initial_angle = initial_angle;
  
}

Character::~Character(){
}


void Character::load(Ogre::SceneManager *smgr){
  string initpath = CHARACTER_PATH;
  initpath = initpath + "/";  

  Message::show("C", "Loading character model:");
  Message::show("C", initpath);

  entity = smgr->createEntity(ent_name, initpath + this->model_name);
 
  scene_node = smgr->getRootSceneNode()->createChildSceneNode();
  scene_node->attachObject(entity);
   
  set_angle(angle);
  
  // Set initial position.
  //location->set_initial_position(node);

}

float* Character::get_position(){
  return (float*) scene_node->getPosition().ptr();
}

void Character::set_position(float pos[3]){
  scene_node->setPosition(Ogre::Vector3(pos));
}

Location* Character::get_location(){
  return location;
}

void Character::set_location(Location *loc){
  if (location != NULL){
    delete(location);
  }
  
  location = loc;
}


float Character::get_angle(){
  return angle;
}

void Character::set_angle(float newangle){
  angle = newangle;
  
  scene_node->yaw(Ogre::Radian(angle));

}

float Character::get_step(){
  return step;
}

void Character::set_step(float newstep){
  step = newstep;
}

string Character::get_name(){
  return ent_name;
}


void Character::forward(){
#ifdef __CHARACTER_DEBUG
  Message::show("C","Moving Forward");
#endif

//   vector3df position;
//   position.set(node->getPosition());

//   float x,z;
//   x = position.X + cos(angle) * step;
//   z = position.Z - sin(angle) * step;
//   position.set(x,position.Y, z);

// #ifdef __CHARACTER_DEBUG
//   Message::show("C cos", string(cos(angle)));
//   Message::show("C sin", string(sin(angle)));
// #endif

//   node->setPosition(position);
//   //animate(CHARANIM_FORWARD);
}

void Character::backward(){
#ifdef __CHARACTER_DEBUG
  Message::show("C","Moving Backward");
#endif

  // vector3df position;
  // position.set(node->getPosition());

  // float x,z;
  // x = position.X - cos(angle) * step;
  // z = position.Z + sin(angle) * step;
  // position.set(x,position.Y, z);

  // node->setPosition(position);
}

void Character::left(){
#ifdef __CHARACTER_DEBUG
  Message::show("C","Moving Left");
#endif

  // vector3df position;
  // position.set(node->getPosition());

  // float x,z;
  // x = position.X - cos(angle + 1.57) * step;
  // z = position.Z + sin(angle + 1.57) * step;
  // position.set(x,position.Y, z);

  // node->setPosition(position);
}

void Character::right(){
#ifdef __CHARACTER_DEBUG
  Message::show("C","Moving Right");
#endif

  // vector3df position;
  // position.set(node->getPosition());

  // float x,z;
  // x = position.X - cos(angle - 1.57) * step;
  // z = position.Z + sin(angle - 1.57) * step;
  // position.set(x,position.Y, z);

  // node->setPosition(position);
}

void Character::rot_left(){  
//   angle += 0.01;
//   if (angle >= 6.28){
//     angle = 0;
//   }

// #ifdef __CHARACTER_DEBUG
//   Message::show("C", "Moving left, new angle:");
//   Message::show("C",string(angle));
// #endif

//   // Update angle.
//   set_angle(angle);
}

void Character::rot_right(){
//   angle -= 0.01;
//   if (angle <= -6.28){
//     angle = 0;
//   }

// #ifdef __CHARACTER_DEBUG
//   Message::show("C", "Moving right, new angle:");
//   Message::show("C",string(angle));
// #endif

//   // Update angle.
//   set_angle(angle);
}


float Character::get_initial_angle(){
  return initial_angle;
}

void Character::play_animation(string name){
  
}

void Character::stop_animation(){
  
}
