#include "PC.hpp"
#include <math.h>

PC::PC(stringc model_name, stringc texture_name, Location *location, f32 initial_angle) :
  Character(model_name, texture_name, location, initial_angle){

  cam_angle = 1.57;
  cam_elevation = 1.57;
  cam_distance = PC_MAXCAMDISTANCE;
  camera = NULL;
}

/*PC::PC(ICameraSceneNode* camera, stringc model_name, Location *location) :
  Character(camera, model_name, location){

  set_camera(camera);
  distance = 50;
  angle = 90;
  }*/

PC::~PC(){
}

/*void PC::set_camera(ICameraSceneNode* camera){
  this->camera = camera;

  }*/


ICameraSceneNode* PC::get_camera(){
  return camera;
}


void PC::load(Ogre::SceneManager *smgr){
  Character::load(dev, scene_selector);

  smgr = dev->getSceneManager();
  
  vector3df r;
  r = node->getRotation();
  r.rotateXYBy(angle * 180 / 3.14);
  
  node->setRotation(r);

  camera = smgr->addCameraSceneNode(node);
  update_camera();
}

void PC::forward(){
  Character::forward();
  camera->setTarget(node->getPosition());  
}


void PC::backward(){
  Character::backward();
  camera->setTarget(node->getPosition());
}


void PC::left(){
  Character::left();
  camera->setTarget(node->getPosition());  
}

void PC::right(){
  Character::right();
  camera->setTarget(node->getPosition());  
}


void PC::camera_nearer(){
  if (cam_distance < PC_MINCAMDISTANCE){
    return;
  }    

  cam_distance -= PC_CAMDISTANCESTEP;
  update_camera();
}

void PC::camera_farer(){
  if (cam_distance > PC_MAXCAMDISTANCE){
    return;
  }
  
  cam_distance += PC_CAMDISTANCESTEP;
  update_camera();
}

void PC::camera_rot_right(){
  if (cam_angle > PC_MAXCAMANGLE){
    cam_angle = PC_MINCAMANGLE;
  }
  
  cam_angle += PC_CAMANGLESTEP;
  update_camera();
}

void PC::camera_rot_left(){
  if (cam_angle < PC_MINCAMANGLE){
    cam_angle = PC_MAXCAMANGLE;
  }  

  cam_angle -= PC_CAMANGLESTEP;  
  update_camera();
}

void PC::camera_lower(){
  if (cam_elevation > PC_MAXCAMELEVATION){
    return;
  }

  cam_elevation += PC_CAMELEVATIONSTEP;
  update_camera();
}

void PC::camera_raise(){
  if (cam_elevation < PC_MINCAMELEVATION){
    return;
  }

  cam_elevation -= PC_CAMELEVATIONSTEP;
  update_camera();
}

void PC::update_camera(){
  f32 x,y,z;
  x = cos(cam_angle) * cam_distance;
  y = sin(cam_elevation) * cam_distance;
  z = sin(cam_angle) * cam_distance;
  
  camera->setPosition(vector3df(x,y,z));
  camera->setTarget(node->getPosition());
}
