
    // PC.hpp
    // Copyright (C) 2013  Giménez, Christian N.

    // This program is free software: you can redistribute it and/or modify
    // it under the terms of the GNU General Public License as published by
    // the Free Software Foundation, either version 3 of the License, or
    // (at your option) any later version.

    // This program is distributed in the hope that it will be useful,
    // but WITHOUT ANY WARRANTY; without even the implied warranty of
    // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    // GNU General Public License for more details.

    // You should have received a copy of the GNU General Public License
    // along with this program.  If not, see <http://www.gnu.org/licenses/>.

    // Domingo 28 De Abril Del 2013    


#ifndef __PC_HPP__
#define __PC_HPP__

#include <string>

using namespace std;

#include <OgreSceneManager.h>
#include <OgreSceneNode.h>
#include <OgreEntity.h>

#include "Location.hpp"
#include "Terminal.hpp"
#include "Character.hpp"

using namespace Terminal;

//#define __PC_DEBUG

#define PC_DEFAULT "pc"
#define PC_MAXCAMDISTANCE 100
#define PC_MINCAMDISTANCE 1
#define PC_MAXCAMANGLE 6.28
#define PC_MINCAMANGLE -6.28
#define PC_MAXCAMELEVATION 1.5
#define PC_MINCAMELEVATION -1.5
#define PC_CAMDISTANCESTEP 1
#define PC_CAMANGLESTEP 0.1
#define PC_CAMELEVATIONSTEP 0.1

/**
   I'm not a Personal Computer!!! I'm a Playable Character!!!   
 */
class PC : public Character{

// protected:
//   /**
//      Camera distance of the PC.
//    */
//   float cam_distance;
//   /**
//      Angle of the camera.

//      In radians.
//    */
//   float cam_angle;

//   /**
//      This is the angle of the elevation of the camera.
     
//      In radians.
//    */
//   float cam_elevation;

//   /**
//      The camera that is around this PC.
//    */
//   ICameraSceneNode* camera;

//   /**
//      This protected method updates the camera position, rotation and elevation.
//    */
//   void update_camera();
  
public:
  /**
     Create a new instance of PC.
     
     Parameters are the same as Character.
   */
  PC(string name, string model_name, string texture_name, Location *location, float initial_angle = 0);
  //PC(ICameraSceneNode *camera, string model_name, Location *location);
  ~PC();

  //ICameraSceneNode* get_camera();
  //void set_camera(ICameraSceneNode* camera);

  virtual void load(Ogre::SceneManager *smgr);

  // virtual void forward();
  // virtual void backward();
  // virtual void left();
  // virtual void right();

  // /**
  //    Move camera nearer from the PC.
  //  */
  // void camera_nearer();
  
  // /**
  //    Move the camera far from the PC.
  // */
  // void camera_farer();

  // /**
  //    Rotate the camera at clockwise(right) around the PC.
  //  */
  // void camera_rot_right();
  // /**
  //    Rotate the camera at non clockwise(left) around the PC.
  //  */
  // void camera_rot_left();


  // void camera_raise();
  // void camera_lower();
};

#endif
