
/*
  WorldBuilder.cpp
  Copyright (C) 2013  Giménez, Christian N. 
  
  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 
  
  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
  GNU General Public License for more details. 
  
  You should have received a copy of the GNU General Public License 
  along with this program.  If not, see <http://www.gnu.org/licenses/>. 
  
  sábado 26 de enero del 2013    */

#include "WorldBuilder.hpp"
#include "Terminal.hpp"

using namespace Terminal;

WorldBuilder::WorldBuilder(){
  world = NULL;
}

WorldBuilder::~WorldBuilder(){
}

World* WorldBuilder::get_world(){  
  Message::show("WB", "get_world()");

  return world;
}

void WorldBuilder::build_world(string name, string initial_location){
  Message::show("WB", "build_world(string,string)");
  Message::show("WB", "Creating world instance...");

  world = new World(name);
  world->set_initial_location(initial_location);
}

void WorldBuilder::add_location(string name){
  Message::show("WB", "add_location(string");

  if (world != NULL){
    world->add_location(name);
  }else{
    Warning::show("WB", "Someone requested me to add a location without creating a world! I ignore the request.");
  }
}
